From: Steven Baltakatei Sandoval <baltakatei@gmail.com>
Date: Fri, 13 Jan 2023 04:09:11 +0000 (+0000)
Subject: feat(up/bkt-read_stdin_psarg):add bash func to read stdin and posarg
X-Git-Tag: 0.7.0~1
X-Git-Url: https://zdv2.bktei.com/gitweb/BK-2020-03.git/commitdiff_plain/b04a0c0f98b848c825faab171cbf52629ab6f2a5?ds=inline;hp=-c

feat(up/bkt-read_stdin_psarg):add bash func to read stdin and posarg

- Note: bash function name: read_stdin_psarg()
---

b04a0c0f98b848c825faab171cbf52629ab6f2a5
diff --git a/unitproc/bkt-read_stdin_psarg b/unitproc/bkt-read_stdin_psarg
new file mode 100644
index 0000000..50f76a7
--- /dev/null
+++ b/unitproc/bkt-read_stdin_psarg
@@ -0,0 +1,50 @@
+#!/usr/bin/env bash
+
+yell() { echo "$0: $*" >&2; } # print script path and all args to stderr
+die() { yell "$*"; exit 111; } # same as yell() but non-zero exit status
+must() { "$@" || die "cannot $*"; } # runs args as command, reports args if command fails
+read_stdin_psarg() {
+    # Desc: Consumes stdin and reads arguments; outputs as stdout lines
+    # Input: stdin (consumes)
+    # Input: args
+    # Output: stdout (newline delimited)
+    # Example: read_stdin_psarg "$@"
+    # Depends: GNU bash (version 5.1.16)
+    local input_stdin input_psarg output;
+
+    # Store stdin
+    if [[ -p /dev/stdin ]]; then
+        input_stdin="$(cat -)";
+    fi;
+    yell "DEBUG:$(declare -p input_stdin)";
+    
+    # Store arguments
+    if [[ $# -gt 0 ]]; then
+        input_psarg="$@";
+    fi;
+    yell "DEBUG:$(declare -p input_psarg)";
+    
+    # Combine as output array elements
+    ## Read in stdin
+    if [[ -n $input_stdin ]]; then
+        while read -r line; do
+            output+=("$line");
+        done < <(printf "%s\n" "$input_stdin");
+    fi;
+    ## Read in positional arguments
+    if [[ -n $input_psarg ]]; then
+        for arg in "$@"; do
+            output+=("$arg");
+        done;
+    fi;
+    yell "DEBUG:$(declare -p output)";        
+
+    # Print to stdout
+    printf "%s\n" "${output[@]}";
+}; # read stdin and positional argument to stdout lines
+
+main() {
+    read_stdin_psarg "$@";
+};
+
+main "$@";